#ifndef __COMMAND_H
#define __COMMAND_H

#include <vector>
#include <string>

class Command
{
 protected:
     std::string mName;
     std::string mHelp;
     std::string mUsage;
 public:
     virtual std::string execute(std::string arg) = 0;
     std::string name(void) { return mName; };
     std::string usage(void) { return mUsage; };
     std::string help(void) { return mHelp; };
};

class CommandManager
{
 private:
     std::vector<Command*> mCommands;
     Command * lookup(std::string name);
 public:
     void add(Command * cmd);
     void remove(std::string name);
     std::string execute(std::string name, std::string arg);
};

#endif
