#include <stdio.h>
#include <stdlib.h>
#include <string>
#include <bot.h>
#include <vector>
#include <cstring>
#include <ctime>
#include <debug.h>

using namespace std;

Bot::Bot(std::string jid, std::string pass, std::string host)
{
 // Zapisz dane
 mJid = jid;
 mPass = pass;
 mHost = host;
 DEBUG("jid=%s\n", this->mJid.c_str());
 // Tworzymy zarzadce polecen
 mCommandManager = new CommandManager();
}

Bot::~Bot()
{
 delete mCommandManager;
}

void Bot::start(void)
{
 // Klasa trzymająca JID bota
 JID jid(mJid + "/dugbot");
 // Tworzymy klienta
 mClient = new Client(jid, mPass);
 mClient->registerConnectionListener(this);
 mClient->registerMessageHandler(this);
 mClient->connect();
}

CommandManager * Bot::commandManager(void)
{
 return mCommandManager;
}

void Bot::onConnect()
{
 // Polaczylismy sie ok
 DEBUG("connected\n");
 // ustawmy status
 DEBUG("set presence\n");
 mClient->setPresence(PresenceAway, 0, "Gentoo, Gentoo uber alles!");
 // FIXME: Moze mozna to w start() zrobic?
 // Pobieramy zarzadce rostera
 mRosterManager = mClient->rosterManager();
 mRosterManager->registerRosterListener(this);
}

void Bot::onDisconnect(ConnectionError e)
{
 DEBUG("disconnected\n");
}

bool Bot::onTLSConnect(const CertInfo& info)
{
 return true;
}

void Bot::handleItemAdded (const JID &jid)
{
}

void Bot::handleItemSubscribed (const JID &jid)
{
}

void Bot::handleItemRemoved (const JID &jid)
{
}

void Bot::handleItemUpdated (const JID &jid)
{
}

void Bot::handleItemUnsubscribed (const JID &jid)
{
}

void Bot::handleRoster (const Roster &roster)
{
}

void Bot::handleRosterPresence (const RosterItem &item, const std::string &resource, Presence presence, const std::string &msg)
{
}

void Bot::handleSelfPresence (const RosterItem &item, const std::string &resource, Presence presence, const std::string &msg)
{
}

bool Bot::handleSubscriptionRequest (const JID &jid, const std::string &msg)
{
 DEBUG("Add %s to user list\n", jid.full().c_str());
 mRosterManager->add(jid, jid.full(), StringList());
 return true;
}

bool Bot::handleUnsubscriptionRequest (const JID &jid, const std::string &msg)
{
 DEBUG("Remove %s to user list\n", jid.full().c_str());
 mRosterManager->remove(jid);
 return true;
}

void Bot::handleNonrosterPresence (Stanza *stanza)
{
}

void Bot::handleRosterError (Stanza *stanza)
{
}

void Bot::handleMessage(Stanza * stanza, MessageSession * session)
{
 int pos;
 string name;
 string arg;
 pos = stanza->body().find(" ");
 if (pos > 0)
 {
  arg = stanza->body().substr(pos + 1);
  name = stanza->body().substr(0, pos);
 }
 else
 {
  name = stanza->body();
  arg = "";
 }
 DEBUG("cmd=%s, arg=%s\n", name.c_str(), arg.c_str());
 this->sendReply(stanza->from().full(), mCommandManager->execute(name, arg));
}

void Bot::sendReply(const JID &to, const std::string &body)
{
 Stanza * reply;
 reply = Stanza::createMessageStanza(to, body);
 mClient->send(reply);
 //delete reply;
}
